天天看点

力扣第一题——两数之和

给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 的那 两个 整数,并返回它们的数组下标。

你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。

你可以按任意顺序返回答案。

示例 1:

输入:nums = [2,7,11,15], target = 9

输出:[0,1]

解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。

示例 2:

输入:nums = [3,2,4], target = 6

输出:[1,2]

示例 3:

输入:nums = [3,3], target = 6

输出:[0,1]

提示:

2 <= nums.length <= 103

-109 <= nums[i] <= 109

-109 <= target <= 109

只会存在一个有效答案

来源:力扣(LeetCode)

链接:https://leetcode-cn.com/problems/two-sum

著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。

解法一:暴力破解
public int[] twoSum(int[] nums, int target) {
        int[] arr = new int[2];
        for (int i = 0; i < nums.length; i++) {
            for (int j = i + 1; j < nums.length; j++) {
                if (nums[i] + nums[j] == target) {
                    arr[0] = i;
                    arr[1] = j;
                }
            }
        }
        return arr;
    }
           
解法二:利用HashMap解题
public int[] twoSum_2(int[] nums, int target) {
        int[] arr = new int[2];
        HashMap<Integer, Integer> map = new HashMap<>();
        for (int i = 0; i < nums.length; i++) {
            //将数组中的数据保存为key,下标存为value
            map.put(nums[i], i);
        }
        for (int i = 0; i < nums.length; i++) {
            int obj = target - nums[i];
            //map.get(obj) != i : 数组中同一个元素在答案里不能重复出现
            if (map.containsKey(obj) && map.get(obj) != i) {
                arr[0] = i;
                arr[1] = map.get(obj);
                break;//假设每种输入只会对应一个答案
            }
        }
        return arr;
    }